// Sistemas Operativos - Curso 2do Semestre 2011
// Tecnologo en Informatica FIng - CETP
//
// Ejemplo IPC - Cliente
// cliente.c

#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdlib.h>
#include <string.h>
#include "shmem.h"
#include "semaforos.h"

int main(int argc, char * argv[])
{
	printf("\33[34mCLIENTE\33[39m: Bienvenido al cliente de pid %d\n", getpid());
	int * var, shmid, semid;

	semid = obtener_semaforos (1, ".", 'R');
	if (semid == -1)
	{
		printf("\33[34mCLIENTE\33[39m: \33[31mError al obtener semaforos.\33[39m\n");
		return 0;
	}
	printf("\33[34mCLIENTE\33[39m: \33[32mSemaforos obtenidos con exito.\33[39m\n");

	shmid = DarIdMemc (".", 'A');
	if (shmid < 0)
	{
		printf ("\33[34CLIENTE\33[39m:: \33[31mError al obtener memoria.\33[39m\n");
		exit(1);
	}
	else
	{	
		printf ("\33[34mCLIENTE\33[39m: \33[32mMemoria obtenida con exito.\33[39m\n");
		var = (int*)DirMemc(shmid);
	}
	while (true)
	{
		
		P (semid, 0);
		printf ("lei el numero %d\n", *var);
		V (semid, 0);
		sleep (1);
	}
}
 
