// Sistemas Operativos - Curso 2do Semestre 2011
// Tecnologo en Informatica FIng - CETP
//
// Manejo de Semaforos
// semaforos.c


#include "semaforos.h"

int crear_semaforos(int cantidad, char* path, char key)
{
	key_t clave;
	int semid;
	clave = ftok(path, key);
	semid = semget(clave, cantidad, 0666|IPC_CREAT);
	if(semid == -1)
		return(-1);
	return(semid);
}

int obtener_semaforos(int cantidad, char* path, char key)
{
	key_t clave;
	int semid;
	clave = ftok(path, key);
	semid = semget(clave, cantidad, 0666);
	if(semid == -1)
		return(-1);
	return(semid);
}
 
int init(int semid, int sem, int valor_ini)
{
	union semun temp;
	temp.val = valor_ini;
	return(semctl(semid, sem, SETVAL, temp));
}

int P(int semid, int sem)
{
	struct sembuf sb = {sem,-1,0};
	return(semop(semid, &sb, 1));
}

int V(int semid, int sem)
{
	struct sembuf sb = {sem, 1, 0};
	return(semop(semid, &sb, 1));
}

int borrar_semaforo(int semid)
{
	union semun arg;
	return(semctl(semid, 0, IPC_RMID, arg));
}
