// Sistemas Operativos - Curso 2do Semestre 2011
// Tecnologo en Informatica FIng - CETP
//
// Manejo de Semaforos
// semaforos.h

#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/types.h>


union semun
{
	int val;
	struct semid_ds *buf;
	unsigned short int *array;
};

int crear_semaforos(int cantidad, char* path, char key);
// Crea nuevo semaforo y devuelve el id.
// path debe ser un archivo exixtente en el sistema
// de archivos sino se creara mal el id.

int obtener_semaforos(int cantidad, char* path, char key);
// Obtiene una cantidad de semaforos

int init(int semid, int sem, int valor_ini);
// Inicializa el semaforo.

int P(int semid, int sem);
// "Proberen" Espera

int V(int semid, int sem);
// "Verhogen" Senhal

int borrar_semaforo(int semid);
// Borra los semaforos

