// Sistemas Operativos - Curso 2do Semestre 2011
// Tecnologo en Informatica FIng - CETP
//
// Manejo de Memoria Compartida
// shmem.c

#include "shmem.h"


int CrearMemc (char * path, char key, int tamano)
{
	int keyy;
	int resu;
	// Pide la key
	keyy = ftok(path,key);
	// Crea el segmento
	resu = shmget(keyy,tamano,IPC_CREAT|0666);
	return resu;
}


int DarIdMemc (char * path, char key)
{
	int keyy;
	int resu;
	// Pide la key
	keyy = ftok(path,key);
	// Pide el id del segmento
	resu = shmget(keyy,0,0666);
	return resu;
}


void * DirMemc (int id)
{
	void * resu;
	// Hace un attach a la memoria
	resu = shmat(id,0,0);
	return resu;
}

int Destruir (int id)
{
	int sal;
	int *sal2;
	// Hace un attach a la memoria
	sal2 = (int *) DirMemc(id);
	// Libera el segmento de memoria
	sal = shmctl(id,IPC_RMID,NULL);
	return sal;
}
